class OrderWorkticketController < ApplicationController
  before_action :set_order

  def show
    template = LabMaintenance.instance.confirmation_template
    r = RxModule::Communicator.call_module_method(
      "rx_plore",
      "/api/tickets/#{template}/svg/#{@order.order_number}?output=#{params[:output]}", :post, @order.to_vca, {
        "Content-Type" => "application/json"
      })

    response.headers['Content-Type'] = if params[:output] == "pdf"
                                         'application/pdf'
                                       elsif params[:output] == "svg"
                                         'image/svg+xml'
                                       else
                                         'text/plain'
                                       end

    render plain: r
  end

  def set_order
    @order = Order.find(params[:id])
  end
end
