import * as React from 'react';
import {observer} from "mobx-react-lite";
import {useModelContext} from "@rx-suite/ui";
import {OrderFieldProps} from "../../../stores/_FieldConstants";
import {BalanceAxisField} from "./BalanceAxisField";
import {GenericInput} from "./GenericInput";


export const AxisField: React.FunctionComponent<OrderFieldProps> = observer(({
                                                                                          disabled,
                                                                                          ...props
                                                                                      }) => {
    const model = useModelContext();
    const cylName = `raw_data.${props.eye}CYL`;
    const isDisabled = !model.viewModel.dig(cylName)

    React.useEffect(()=> {
        if (isDisabled){
            model.nestedAssignment(props.name, '');
        }
    },[isDisabled, model, props.name])

    if (model.viewModel.job_type === "RB" || model.viewModel.job_type === "LB") {
        return <BalanceAxisField disabled={isDisabled} {...props}/>
    } else {
        return <GenericInput disabled={isDisabled} {...props}/>
    }
});