import * as React from 'react';
import {useModelContext} from "@rx-suite/ui";
import {observer} from "mobx-react-lite";
import {OrderFieldProps, prismOptions} from "../../../stores/_FieldConstants";
import {GenericInput} from "./GenericInput";

export const PrismAmountField: React.FunctionComponent<OrderFieldProps> = observer(({eye, disabled, ...props}) => {
    const model = useModelContext();

    const firstAxis = model.viewModel.dig(`raw_data.${eye}PRVA1`)
    const isDir = prismOptions.includes(firstAxis);

    React.useEffect(() => {
        if(!isDir) {
            model.nestedAssignment(`raw_data.${eye}PRVA2`, '')
        }
    }, [eye, isDir, model]);


    return (
        <GenericInput eye={eye} disabled={!isDir || disabled} {...props} />
    )
})