import * as React from 'react';
import {observer} from "mobx-react-lite";
import {Grid} from "@material-ui/core";
import Typography from "@material-ui/core/Typography";
import {t} from "@lingui/macro";
import {ShippingMethodSelect} from "./ShippingMethodSelect";
import {ShippingFields} from "./ShippingFields";
import {LabMaintenanceStore} from "../../../stores/LabMaintenanceStore";

type Props = {
    className: string
}
export const ShippingInformation: React.FunctionComponent<Props> = observer(({ className }) => {
    if(!LabMaintenanceStore.selectedModel?.display_shipping_info) {
        return null;
    }

    return(
        <Grid container className={className}>
            <Grid item xs={12}>
                <Typography variant={"h6"}>{t`Shipping Information`}</Typography>
            </Grid>
            <Grid item xs={12}>
                <Grid container spacing={2}>
                    <Grid item xs={12} lg={4}>
                        <ShippingMethodSelect/>
                    </Grid>
                    <ShippingFields/>
                </Grid>
            </Grid>
        </Grid>
    )
});