import {observer} from 'mobx-react-lite';
import * as React from 'react';
import {useOrderEntryStore} from "../../../hooks/useOrderEntryStore";
import {FormHelperText, Grid, makeStyles} from "@material-ui/core";
import {FrameFindInput} from "./FrameFindInput";
import {FrameFindButton} from "./FrameFindButton";

const useStyles = makeStyles(() => ({
    wrapper: {
        width: '100%'
    }
}));

export const FrameFindInputs = observer(() => {
    const store = useOrderEntryStore();
    const classes = useStyles();
    const error = store.fetchingFrameFindOptionsError;

    return <Grid container className={classes.wrapper}>
        {store.frameFindOptions.map(o => {
            return <Grid item xs={12} md>
                <FrameFindInput option={o} key={o.id}/>
            </Grid>
        })}
        <Grid item xs={12} md>
            <FrameFindButton/>
        </Grid>
        <Grid item xs={12}>
            {error && <FormHelperText error>{error}</FormHelperText>}
        </Grid>
    </Grid>
});