# frozen_string_literal: true

class SyncOrdersJob < ApplicationJob
  def perform
    last_sync = OrderSyncStatus.instance.sync_started_at || nil

    OrderSyncStatus.wrap do
      Order.quietly do
        RxModule::Communicator::Rxuniverse.customers[:models].each do |cust|
          RxModule::Communicator::Rxuniverse.orders_by_customer_internal(cust[:custNumber], last_sync).each do |rxu_ord|
            the_order = Order.find_or_initialize_by(order_number: rxu_ord[:orderNumber])
            the_order.sync_with_rxuniverse!
          rescue StandardError => e
            Rails.logger.warn("Sync failed for order #{rxu_ord}, #{e}")
          end
        rescue StandardError => e
          unless e&.message == "no records found"
            Rails.logger.warn("Sync failed for customer #{cust}, #{e}")
          end
        end
      end
    end
  end
end
