class CreateStyleMaterials < ActiveRecord::Migration[6.0]
  def change
    create_table :style_materials do |t|
      t.belongs_to :style, null: false, foreign_key: true
      t.string :material_code
      t.string :tint_code
      t.string :treat_code
      t.string :material_description
      t.boolean :active

      t.timestamps
    end

    add_index :style_materials, [:style_id, :material_code, :tint_code, :treat_code], name: :index_style_materials_on_keys
  end
end
