# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# This file is the source Rails uses to define your schema when running `rails
# db:schema:load`. When creating a new database, `rails db:schema:load` tends to
# be faster and is potentially less error prone than running all of your
# migrations from scratch. Old migrations may fail to apply correctly if those
# migrations use external dependencies or application code.
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 2024_02_21_135333) do

  create_table "active_storage_attachments", force: :cascade do |t|
    t.string "name", null: false
    t.string "record_type", null: false
    t.bigint "record_id", null: false
    t.bigint "blob_id", null: false
    t.datetime "created_at", null: false
    t.index ["blob_id"], name: "index_active_storage_attachments_on_blob_id"
    t.index ["record_type", "record_id", "name", "blob_id"], name: "index_active_storage_attachments_uniqueness", unique: true
  end

  create_table "active_storage_blobs", force: :cascade do |t|
    t.string "key", null: false
    t.string "filename", null: false
    t.string "content_type"
    t.text "metadata"
    t.bigint "byte_size", null: false
    t.string "checksum", null: false
    t.datetime "created_at", null: false
    t.index ["key"], name: "index_active_storage_blobs_on_key", unique: true
  end

  create_table "addons", force: :cascade do |t|
    t.string "code"
    t.string "desc"
    t.boolean "ar"
    t.boolean "tint"
    t.boolean "mirror"
    t.boolean "backside"
    t.boolean "uv"
    t.boolean "harden"
    t.boolean "dropball"
    t.boolean "etch"
    t.boolean "polish"
    t.boolean "active"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["code"], name: "index_addons_on_code", unique: true
  end

  create_table "config_customers", force: :cascade do |t|
    t.bigint "config_id", null: false
    t.bigint "customer_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["config_id"], name: "index_config_customers_on_config_id"
    t.index ["customer_id"], name: "index_config_customers_on_customer_id"
  end

  create_table "configs", force: :cascade do |t|
    t.string "user_id"
    t.string "user_name"
    t.string "user_email"
    t.string "pd"
    t.string "default_job_type"
    t.boolean "edge_frame"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "last_known_customer_id"
    t.boolean "continuous_entry", default: false
    t.boolean "allow_personalization", default: true, null: false
    t.string "default_frame_status", default: "U", null: false
    t.text "selected_order_columns"
    t.boolean "show_confirmation"
  end

  create_table "customers", force: :cascade do |t|
    t.string "number", null: false
    t.string "name"
    t.string "rpt_1"
    t.string "rpt_2"
    t.string "rpt_3"
    t.string "rpt_4"
    t.boolean "active"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.bigint "ship_method_monday_id"
    t.bigint "ship_method_tuesday_id"
    t.bigint "ship_method_wednesday_id"
    t.bigint "ship_method_thursday_id"
    t.bigint "ship_method_friday_id"
    t.bigint "ship_method_saturday_id"
    t.bigint "ship_method_sunday_id"
    t.string "rpt_5"
    t.index ["number"], name: "index_customers_on_number", unique: true
    t.index ["ship_method_friday_id"], name: "index_customers_on_ship_method_friday_id"
    t.index ["ship_method_monday_id"], name: "index_customers_on_ship_method_monday_id"
    t.index ["ship_method_saturday_id"], name: "index_customers_on_ship_method_saturday_id"
    t.index ["ship_method_sunday_id"], name: "index_customers_on_ship_method_sunday_id"
    t.index ["ship_method_thursday_id"], name: "index_customers_on_ship_method_thursday_id"
    t.index ["ship_method_tuesday_id"], name: "index_customers_on_ship_method_tuesday_id"
    t.index ["ship_method_wednesday_id"], name: "index_customers_on_ship_method_wednesday_id"
  end

  create_table "dashboard_component_placements", force: :cascade do |t|
    t.integer "x"
    t.integer "y"
    t.integer "height"
    t.integer "width"
    t.bigint "dashboard_component_id"
    t.bigint "dashboard_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["dashboard_component_id"], name: "index_dashboard_component_placements_on_dashboard_component_id"
    t.index ["dashboard_id"], name: "index_dashboard_component_placements_on_dashboard_id"
  end

  create_table "dashboard_components", force: :cascade do |t|
    t.string "name"
    t.string "desc"
    t.text "parameters"
    t.integer "refresh_interval"
    t.text "data"
    t.string "display_type"
    t.bigint "dashboard_target_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "display_options"
    t.string "last_run_error"
    t.string "run_user_id"
    t.string "run_token"
    t.boolean "queued", default: false, null: false
    t.index ["dashboard_target_id"], name: "index_dashboard_components_on_dashboard_target_id"
  end

  create_table "dashboard_group_dashboards", force: :cascade do |t|
    t.bigint "dashboard_group_id"
    t.bigint "dashboard_id"
    t.integer "rank"
    t.integer "interval"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["dashboard_group_id"], name: "index_dashboard_group_dashboards_on_dashboard_group_id"
    t.index ["dashboard_id"], name: "index_dashboard_group_dashboards_on_dashboard_id"
  end

  create_table "dashboard_groups", force: :cascade do |t|
    t.string "name"
    t.string "desc"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "dashboard_targets", force: :cascade do |t|
    t.string "module_id"
    t.string "module_name"
    t.string "dashboard_id"
    t.string "name"
    t.string "desc"
    t.text "ui_hints"
    t.text "parameters"
    t.text "returns"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "dashboards", force: :cascade do |t|
    t.string "name"
    t.string "desc"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.boolean "header_enabled", default: false
  end

  create_table "delayed_jobs", force: :cascade do |t|
    t.integer "priority", default: 0, null: false
    t.integer "attempts", default: 0, null: false
    t.text "handler", null: false
    t.text "last_error"
    t.datetime "run_at"
    t.datetime "locked_at"
    t.datetime "failed_at"
    t.string "locked_by"
    t.string "queue"
    t.datetime "created_at", precision: 6
    t.datetime "updated_at", precision: 6
    t.index ["priority", "run_at"], name: "delayed_jobs_priority"
  end

  create_table "lab_layout_components", force: :cascade do |t|
    t.bigint "lab_layout_id"
    t.string "name"
    t.string "component_type"
    t.string "machine_sn"
    t.string "machine_group_ids"
    t.integer "alert_after"
    t.float "x"
    t.float "y"
    t.float "width"
    t.float "height"
    t.decimal "z_index", precision: 18
    t.float "aspect_ratio"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.text "options"
    t.index ["lab_layout_id"], name: "index_lab_layout_components_on_lab_layout_id"
  end

  create_table "lab_layouts", force: :cascade do |t|
    t.string "name"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.integer "resolution_x", default: 1920
    t.integer "resolution_y", default: 1080
  end

  create_table "lab_maintenances", force: :cascade do |t|
    t.string "lab_id"
    t.boolean "display_addresses", default: false, null: false
    t.boolean "display_wanted_date", default: false, null: false
    t.boolean "display_hold_switch", default: false, null: false
    t.boolean "display_uncut_orders", default: false, null: false
    t.boolean "split_name_on_order_entry", default: false, null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "confirmation_template", default: "RXSITE"
    t.boolean "display_shipping_info", default: true
    t.boolean "display_quick_codes", default: true
    t.index ["lab_id"], name: "index_lab_maintenances_on_lab_id", unique: true
  end

  create_table "order_addons", force: :cascade do |t|
    t.bigint "order_id", null: false
    t.bigint "addon_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["addon_id"], name: "index_order_addons_on_addon_id"
    t.index ["order_id"], name: "index_order_addons_on_order_id"
  end

  create_table "orders", force: :cascade do |t|
    t.string "order_number"
    t.string "customer_num"
    t.string "customer_name"
    t.string "customer_city"
    t.date "date_completed"
    t.date "date_received"
    t.date "date_ordered"
    t.string "cust_job_id"
    t.string "po_number"
    t.string "release_number"
    t.string "tray"
    t.string "ship_to_num"
    t.string "ship_to_name"
    t.string "ship_to_address1"
    t.string "ship_to_address2"
    t.string "ship_to_address3"
    t.string "ship_to_address4"
    t.string "ship_to_code"
    t.string "job_type"
    t.string "lens_color"
    t.string "lens_treat"
    t.string "_fstatus"
    t.string "fupc"
    t.string "fram"
    t.string "fcol"
    t.string "_fmupc"
    t.string "_fsku"
    t.string "trace_id"
    t.text "raw_data"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.bigint "style_id"
    t.bigint "style_type_id"
    t.bigint "style_material_id"
    t.bigint "shipping_method_id"
    t.datetime "last_sync_time"
    t.string "last_sync_message"
    t.boolean "has_synced_once"
    t.bigint "customer_id"
    t.string "frame_sku"
    t.boolean "hold_at_lab", default: false, null: false
    t.string "comments", limit: 385
    t.string "submitted_by"
    t.boolean "is_valid", default: true
    t.string "origin"
    t.string "job_track_station"
    t.string "job_track_description"
    t.boolean "is_shipped", default: false
    t.index ["customer_id"], name: "index_orders_on_customer_id"
    t.index ["shipping_method_id"], name: "index_orders_on_shipping_method_id"
    t.index ["style_id"], name: "index_orders_on_style_id"
    t.index ["style_material_id"], name: "index_orders_on_style_material_id"
    t.index ["style_type_id"], name: "index_orders_on_style_type_id"
  end

  create_table "quick_codes", force: :cascade do |t|
    t.bigint "style_id", null: false
    t.bigint "style_material_id", null: false
    t.bigint "style_type_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.integer "code", null: false
    t.index ["style_id", "style_material_id", "style_type_id"], name: "quick_codes_index", unique: true
    t.index ["style_id"], name: "index_quick_codes_on_style_id"
    t.index ["style_material_id"], name: "index_quick_codes_on_style_material_id"
    t.index ["style_type_id"], name: "index_quick_codes_on_style_type_id"
  end

  create_table "rx_module_logger_configs", force: :cascade do |t|
    t.string "location"
    t.string "level"
    t.integer "archive_count"
    t.integer "max_size"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "rx_module_model_audit_lines", force: :cascade do |t|
    t.bigint "rx_module_model_audit_id", null: false
    t.text "before"
    t.text "after"
    t.string "column"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["rx_module_model_audit_id"], name: "index_rx_module_model_audit_lines_on_rx_module_model_audit_id"
  end

  create_table "rx_module_model_audits", force: :cascade do |t|
    t.string "user_id"
    t.string "user_email"
    t.string "user_role"
    t.string "table"
    t.string "action"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.bigint "model_id"
  end

  create_table "rx_module_serial_numbers", force: :cascade do |t|
    t.string "owner"
    t.bigint "start_number"
    t.bigint "next_number"
    t.integer "padding"
    t.string "column_name", default: "number"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "prefix", limit: 3, default: ""
  end

  create_table "rx_module_tokens", force: :cascade do |t|
    t.string "value"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.integer "owner"
  end

  create_table "rx_module_update_histories", force: :cascade do |t|
    t.string "user"
    t.string "from_version"
    t.string "to_version"
    t.boolean "was_error"
    t.string "error_msg"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.boolean "in_progress"
    t.index ["created_at"], name: "index_rx_module_update_histories_on_created_at"
  end

  create_table "rx_module_worker_broadcasts", force: :cascade do |t|
    t.string "model_global_id"
    t.string "action"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "channel_class"
  end

  create_table "shipping_methods", force: :cascade do |t|
    t.string "code"
    t.string "description"
    t.boolean "ship_to_required"
    t.boolean "active", default: true, null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["code"], name: "index_shipping_methods_on_code", unique: true
  end

  create_table "stock_lenses", force: :cascade do |t|
    t.string "stock_number"
    t.string "manufacturer_code"
    t.string "manufacturer_desc"
    t.string "lens_code"
    t.string "lens_desc"
    t.string "material_code"
    t.string "material_desc"
    t.string "tint_code"
    t.string "tint_desc"
    t.string "pretreatment_code"
    t.string "pretreatment_desc"
    t.string "thick_code"
    t.string "sph"
    t.string "cyl"
    t.string "add"
    t.string "dia"
    t.string "rt_opc"
    t.string "lt_opc"
    t.boolean "active"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.boolean "requires_trace"
  end

  create_table "stock_order_items", force: :cascade do |t|
    t.string "item_identifier"
    t.string "description"
    t.integer "quantity"
    t.string "item_type"
    t.bigint "stock_order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["stock_order_id"], name: "index_stock_order_items_on_stock_order_id"
  end

  create_table "stock_orders", force: :cascade do |t|
    t.string "order_number"
    t.string "reference_number"
    t.string "po_number"
    t.datetime "date_ordered"
    t.datetime "date_completed"
    t.bigint "user_id"
    t.bigint "customer_id"
    t.bigint "shipping_method_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "status", default: "open"
    t.string "release_number"
    t.index ["customer_id"], name: "index_stock_orders_on_customer_id"
    t.index ["shipping_method_id"], name: "index_stock_orders_on_shipping_method_id"
  end

  create_table "style_materials", force: :cascade do |t|
    t.bigint "style_id", null: false
    t.string "material_code"
    t.string "tint_code"
    t.string "treat_code"
    t.string "material_description"
    t.boolean "active"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["style_id", "material_code", "tint_code", "treat_code"], name: "index_style_materials_on_keys", unique: true
    t.index ["style_id"], name: "index_style_materials_on_style_id"
  end

  create_table "style_types", force: :cascade do |t|
    t.string "style_type"
    t.boolean "active"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["style_type"], name: "index_style_types_on_style_type", unique: true
  end

  create_table "styles", force: :cascade do |t|
    t.string "style"
    t.string "description"
    t.boolean "requires_trace"
    t.boolean "active"
    t.bigint "style_type_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["style"], name: "index_styles_on_style", unique: true
    t.index ["style_type_id"], name: "index_styles_on_style_type_id"
  end

  create_table "sync_statuses", force: :cascade do |t|
    t.datetime "sync_started_at"
    t.datetime "sync_ended_at"
    t.boolean "in_progress"
    t.string "type"
    t.boolean "failed"
    t.text "error_message"
    t.boolean "queued"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  add_foreign_key "active_storage_attachments", "active_storage_blobs", column: "blob_id"
  add_foreign_key "config_customers", "configs"
  add_foreign_key "config_customers", "customers"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_friday_id"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_monday_id"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_saturday_id"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_sunday_id"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_thursday_id"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_tuesday_id"
  add_foreign_key "customers", "shipping_methods", column: "ship_method_wednesday_id"
  add_foreign_key "dashboard_component_placements", "dashboard_components", on_update: :cascade, on_delete: :cascade
  add_foreign_key "dashboard_component_placements", "dashboards", on_update: :cascade, on_delete: :cascade
  add_foreign_key "dashboard_components", "dashboard_targets", on_update: :cascade, on_delete: :cascade
  add_foreign_key "dashboard_group_dashboards", "dashboard_groups", on_update: :cascade, on_delete: :cascade
  add_foreign_key "dashboard_group_dashboards", "dashboards", on_update: :cascade, on_delete: :cascade
  add_foreign_key "lab_layout_components", "lab_layouts", on_update: :cascade, on_delete: :cascade
  add_foreign_key "order_addons", "addons"
  add_foreign_key "order_addons", "orders"
  add_foreign_key "orders", "customers"
  add_foreign_key "orders", "shipping_methods"
  add_foreign_key "orders", "style_materials"
  add_foreign_key "orders", "style_types"
  add_foreign_key "orders", "styles"
  add_foreign_key "quick_codes", "style_materials"
  add_foreign_key "quick_codes", "style_types"
  add_foreign_key "quick_codes", "styles"
  add_foreign_key "rx_module_model_audit_lines", "rx_module_model_audits"
  add_foreign_key "stock_order_items", "stock_orders"
  add_foreign_key "stock_orders", "customers"
  add_foreign_key "stock_orders", "shipping_methods"
  add_foreign_key "style_materials", "styles"
  add_foreign_key "styles", "style_types"
end
